#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_TherionEventWeightCFG.h"
std::auto_ptr<Fish_TherionEventWeightCFG> Fish_TherionEventWeightCFG::msSingleton(nullptr);

int Fish_TherionEventWeightCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TherionEventWeightCFGData* Fish_TherionEventWeightCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_TherionEventWeightCFGData>& Fish_TherionEventWeightCFG::GetMapData()
{
	return mMapData;
}

void Fish_TherionEventWeightCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_TherionEventWeightCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TherionEventWeightCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mEventName = element->Attribute("EventName");
		data.mEventWeight = element->IntAttribute("EventWeight");
		data.mTreasureWeight = element->IntAttribute("TreasureWeight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_TherionEventWeightCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TherionEventWeightCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_TherionEventWeightCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_TherionEventWeightCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_TherionEventWeightCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "EventName", data.mEventName);
		LuaCfgHelper::readInt(L, "EventWeight", data.mEventWeight);
		LuaCfgHelper::readInt(L, "TreasureWeight", data.mTreasureWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_TherionEventWeightCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_TherionEventWeightCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_TherionEventWeightCFG* Fish_TherionEventWeightCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TherionEventWeightCFG());
	}
	return msSingleton.get();
}

void Fish_TherionEventWeightCFG::Release()
{
	msSingleton.reset(nullptr);
}
